## madness 0.1.0

=== DESCRIPTION ===
Package: madness
Maintainer: Steven E. Pav <shabbychef@gmail.com>
Authors@R: c(person(c("Steven", "E."), "Pav", role=c("aut","cre"),
    email="shabbychef@gmail.com"))
Version: 0.1.0
Date: 2015-12-14
License: LGPL-3
Title: Automatic Differentiation of Multivariate Operations
BugReports: https://github.com/shabbychef/madness/issues
Description: An object that supports automatic differentiation
    of matrix- and multidimensional-valued functions with
    respect to multidimensional independent variables.
    Automatic differentiation is via 'forward accumulation'.
Depends: R (>= 3.0.2)
Imports: matrixcalc, expm, methods
Suggests: testthat, knitr
URL: https://github.com/shabbychef/madness
Collate: 'AllClass.r' 'utils.r' 'Ops.r' 'bind.r' 'blockrep.r'
        'coerce.r' 'det.r' 'elwise.r' 'madness_pkg.r' 'matwise.r'
        'numderiv.r' 'reshape.r' 'solve.r' 'sum.r' 'sums.r' 'theta.r'
        'trace.r' 'twomoments.r' 'vcov.r' 'vec.r'
RoxygenNote: 5.0.0
NeedsCompilation: no
Packaged: 2015-12-15 18:31:48 UTC; spav
Author: Steven E. Pav [aut, cre]
Repository: CRAN
Date/Publication: 2015-12-15 20:49:11

## madness 0.2.0

=== DESCRIPTION ===
Package: madness
Maintainer: Steven E. Pav <shabbychef@gmail.com>
Authors@R: c(person(c("Steven", "E."), "Pav", role=c("aut","cre"),
    email="shabbychef@gmail.com"))
Version: 0.2.0
Date: 2016-01-19
License: LGPL-3
Title: Automatic Differentiation of Multivariate Operations
BugReports: https://github.com/shabbychef/madness/issues
Description: An object that supports automatic differentiation
    of matrix- and multidimensional-valued functions with 
    respect to multidimensional independent variables. 
    Automatic differentiation is via 'forward accumulation'.
Depends: R (>= 3.2.0)
Imports: matrixcalc, expm, methods
Suggests: testthat, R.rsp, knitr
URL: https://github.com/shabbychef/madness
VignetteBuilder: R.rsp
Collate: 'AllClass.r' 'bind.r' 'blockrep.r' 'coerce.r' 'det.r' 'diag.r'
        'eigen.r' 'elwise.r' 'madness_pkg.r' 'matwise.r' 'max.r'
        'norm.r' 'numderiv.r' 'Ops.r' 'reshape.r' 'solve.r' 'sum.r'
        'sums.r' 'theta.r' 'to_objective.r' 'trace.r' 'twomoments.r'
        'utils.r' 'vcov.r' 'vec.r'
NeedsCompilation: no
Packaged: 2016-01-20 05:59:55 UTC; spav
Author: Steven E. Pav [aut, cre]
Repository: CRAN
Date/Publication: 2016-01-20 09:12:28

## madness 0.2.1

=== DESCRIPTION ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Maintainer: Steven E. Pav <shabbychef@gmail.com>
 Authors@R: c(person(c("Steven", "E."), "Pav", role=c("aut","cre"),
     email="shabbychef@gmail.com"))
-Version: 0.2.0
-Date: 2016-01-19
+Version: 0.2.1
+Date: 2017-04-13
 License: LGPL-3
 Title: Automatic Differentiation of Multivariate Operations
 BugReports: https://github.com/shabbychef/madness/issues
@@ -22,7 +22,7 @@
         'sums.r' 'theta.r' 'to_objective.r' 'trace.r' 'twomoments.r'
         'utils.r' 'vcov.r' 'vec.r'
 NeedsCompilation: no
-Packaged: 2016-01-20 05:59:55 UTC; spav
+Packaged: 2017-04-14 05:22:01 UTC; spav
 Author: Steven E. Pav [aut, cre]
 Repository: CRAN
-Date/Publication: 2016-01-20 09:12:28
+Date/Publication: 2017-04-14 14:49:46 UTC

## madness 0.2.2

=== DESCRIPTION ===
Package: madness
Maintainer: Steven E. Pav <shabbychef@gmail.com>
Authors@R: c(person(c("Steven", "E."), "Pav", role=c("aut","cre"),
    email="shabbychef@gmail.com"))
Version: 0.2.2
Date: 2017-04-25
License: LGPL-3
Title: Automatic Differentiation of Multivariate Operations
BugReports: https://github.com/shabbychef/madness/issues
Description: An object that supports automatic differentiation
    of matrix- and multidimensional-valued functions with 
    respect to multidimensional independent variables. 
    Automatic differentiation is via 'forward accumulation'.
Depends: R (>= 3.2.0)
Imports: Matrix, matrixcalc, expm, methods
Suggests: testthat, R.rsp, knitr
URL: https://github.com/shabbychef/madness
VignetteBuilder: R.rsp
Collate: 'AllClass.r' 'utils.r' 'Ops.r' 'bind.r' 'blockrep.r'
        'coerce.r' 'det.r' 'diag.r' 'eigen.r' 'elwise.r'
        'madness_pkg.r' 'matwise.r' 'max.r' 'norm.r' 'numderiv.r'
        'reshape.r' 'solve.r' 'sum.r' 'sums.r' 'theta.r'
        'to_objective.r' 'trace.r' 'twomoments.r' 'vcov.r' 'vec.r'
RoxygenNote: 6.0.1
NeedsCompilation: no
Packaged: 2017-04-26 04:53:12 UTC; spav
Author: Steven E. Pav [aut, cre]
Repository: CRAN
Date/Publication: 2017-04-26 05:36:59 UTC

## madness 0.2.3

=== DESCRIPTION ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Maintainer: Steven E. Pav <shabbychef@gmail.com>
 Authors@R: c(person(c("Steven", "E."), "Pav", role=c("aut","cre"),
     email="shabbychef@gmail.com"))
-Version: 0.2.2
-Date: 2017-04-25
+Version: 0.2.3
+Date: 2018-02-14
 License: LGPL-3
 Title: Automatic Differentiation of Multivariate Operations
 BugReports: https://github.com/shabbychef/madness/issues
@@ -23,7 +23,7 @@
         'to_objective.r' 'trace.r' 'twomoments.r' 'vcov.r' 'vec.r'
 RoxygenNote: 6.0.1
 NeedsCompilation: no
-Packaged: 2017-04-26 04:53:12 UTC; spav
+Packaged: 2018-02-15 05:31:39 UTC; spav
 Author: Steven E. Pav [aut, cre]
 Repository: CRAN
-Date/Publication: 2017-04-26 05:36:59 UTC
+Date/Publication: 2018-02-15 23:15:22 UTC

## madness 0.2.4

=== DESCRIPTION ===
Package: madness
Maintainer: Steven E. Pav <shabbychef@gmail.com>
Authors@R: c(person(c("Steven", "E."), "Pav", 
    role=c("aut","cre"),
    email="shabbychef@gmail.com",
    comment = c(ORCID = "0000-0002-4197-6195")))
Version: 0.2.4
Date: 2018-08-26
License: LGPL-3
Title: Automatic Differentiation of Multivariate Operations
BugReports: https://github.com/shabbychef/madness/issues
Description: An object that supports automatic differentiation
    of matrix- and multidimensional-valued functions with 
    respect to multidimensional independent variables. 
    Automatic differentiation is via 'forward accumulation'.
Depends: R (>= 3.2.0)
Imports: Matrix, matrixcalc, expm, methods
Suggests: testthat, dplyr, tidyr, lubridate, SharpeR, sandwich,
        formatR, knitr
URL: https://github.com/shabbychef/madness
VignetteBuilder: knitr
Collate: 'AllClass.r' 'utils.r' 'Ops.r' 'bind.r' 'blockrep.r'
        'coerce.r' 'data.r' 'det.r' 'diag.r' 'eigen.r' 'elwise.r'
        'madness_pkg.r' 'matwise.r' 'max.r' 'norm.r' 'numderiv.r'
        'reshape.r' 'solve.r' 'sum.r' 'sums.r' 'theta.r'
        'to_objective.r' 'trace.r' 'twomoments.r' 'vcov.r' 'vec.r'
RoxygenNote: 6.0.1
NeedsCompilation: no
Packaged: 2018-08-27 05:47:09 UTC; root
Author: Steven E. Pav [aut, cre] (<https://orcid.org/0000-0002-4197-6195>)
Repository: CRAN
Date/Publication: 2018-08-27 06:22:15 UTC

## madness 0.2.5

=== DESCRIPTION ===
--- 
+++ 
@@ -4,8 +4,8 @@
     role=c("aut","cre"),
     email="shabbychef@gmail.com",
     comment = c(ORCID = "0000-0002-4197-6195")))
-Version: 0.2.4
-Date: 2018-08-26
+Version: 0.2.5
+Date: 2018-08-27
 License: LGPL-3
 Title: Automatic Differentiation of Multivariate Operations
 BugReports: https://github.com/shabbychef/madness/issues
@@ -26,7 +26,7 @@
         'to_objective.r' 'trace.r' 'twomoments.r' 'vcov.r' 'vec.r'
 RoxygenNote: 6.0.1
 NeedsCompilation: no
-Packaged: 2018-08-27 05:47:09 UTC; root
+Packaged: 2018-08-28 04:59:55 UTC; root
 Author: Steven E. Pav [aut, cre] (<https://orcid.org/0000-0002-4197-6195>)
 Repository: CRAN
-Date/Publication: 2018-08-27 06:22:15 UTC
+Date/Publication: 2018-08-29 08:12:24 UTC

## madness 0.2.6

=== DESCRIPTION ===
--- 
+++ 
@@ -4,8 +4,8 @@
     role=c("aut","cre"),
     email="shabbychef@gmail.com",
     comment = c(ORCID = "0000-0002-4197-6195")))
-Version: 0.2.5
-Date: 2018-08-27
+Version: 0.2.6
+Date: 2019-04-18
 License: LGPL-3
 Title: Automatic Differentiation of Multivariate Operations
 BugReports: https://github.com/shabbychef/madness/issues
@@ -24,9 +24,9 @@
         'madness_pkg.r' 'matwise.r' 'max.r' 'norm.r' 'numderiv.r'
         'reshape.r' 'solve.r' 'sum.r' 'sums.r' 'theta.r'
         'to_objective.r' 'trace.r' 'twomoments.r' 'vcov.r' 'vec.r'
-RoxygenNote: 6.0.1
+RoxygenNote: 6.1.1
 NeedsCompilation: no
-Packaged: 2018-08-28 04:59:55 UTC; root
+Packaged: 2019-04-19 04:34:05 UTC; root
 Author: Steven E. Pav [aut, cre] (<https://orcid.org/0000-0002-4197-6195>)
 Repository: CRAN
-Date/Publication: 2018-08-29 08:12:24 UTC
+Date/Publication: 2019-04-19 05:10:03 UTC

## madness 0.2.7

=== DESCRIPTION ===
Package: madness
Maintainer: Steven E. Pav <shabbychef@gmail.com>
Authors@R: c(person(c("Steven", "E."), "Pav", 
    role=c("aut","cre"),
    email="shabbychef@gmail.com",
    comment = c(ORCID = "0000-0002-4197-6195")))
Version: 0.2.7
Date: 2020-02-07
License: LGPL-3
Title: Automatic Differentiation of Multivariate Operations
BugReports: https://github.com/shabbychef/madness/issues
Description: An object that supports automatic differentiation
    of matrix- and multidimensional-valued functions with 
    respect to multidimensional independent variables. 
    Automatic differentiation is via 'forward accumulation'.
Depends: R (>= 3.2.0)
Imports: Matrix, matrixcalc, expm, methods
Suggests: testthat, dplyr, tidyr, lubridate, SharpeR, sandwich,
        formatR, knitr
URL: https://github.com/shabbychef/madness
LazyData: true
VignetteBuilder: knitr
Collate: 'AllClass.r' 'bind.r' 'blockrep.r' 'coerce.r' 'data.r' 'det.r'
        'diag.r' 'eigen.r' 'elwise.r' 'madness_pkg.r' 'matwise.r'
        'max.r' 'norm.r' 'numderiv.r' 'Ops.r' 'reshape.r' 'solve.r'
        'sum.r' 'sums.r' 'theta.r' 'to_objective.r' 'trace.r'
        'twomoments.r' 'utils.r' 'vcov.r' 'vec.r'
NeedsCompilation: no
Packaged: 2020-02-08 05:52:43 UTC; spav
Author: Steven E. Pav [aut, cre] (<https://orcid.org/0000-0002-4197-6195>)
Repository: CRAN
Date/Publication: 2020-02-08 07:00:03 UTC

## madness 0.2.8

=== DESCRIPTION ===
Package: madness
Maintainer: Steven E. Pav <shabbychef@gmail.com>
Authors@R: c(person(c("Steven", "E."), "Pav", 
    role=c("aut","cre"),
    email="shabbychef@gmail.com",
    comment = c(ORCID = "0000-0002-4197-6195")))
Version: 0.2.8
Date: 2023-08-20
License: LGPL-3
Title: Automatic Differentiation of Multivariate Operations
BugReports: https://github.com/shabbychef/madness/issues
Description: An object that supports automatic differentiation
    of matrix- and multidimensional-valued functions with 
    respect to multidimensional independent variables. 
    Automatic differentiation is via 'forward accumulation'.
Depends: R (>= 3.2.0)
Imports: Matrix, matrixcalc, expm, methods
Suggests: testthat, dplyr, tidyr, lubridate, SharpeR, sandwich,
        formatR, knitr
URL: https://github.com/shabbychef/madness
LazyData: true
VignetteBuilder: knitr
Collate: 'AllClass.r' 'utils.r' 'Ops.r' 'bind.r' 'blockrep.r'
        'coerce.r' 'data.r' 'det.r' 'diag.r' 'eigen.r' 'elwise.r'
        'madness_pkg.r' 'matwise.r' 'max.r' 'norm.r' 'numderiv.r'
        'reshape.r' 'solve.r' 'sum.r' 'sums.r' 'theta.r'
        'to_objective.r' 'trace.r' 'twomoments.r' 'vcov.r' 'vec.r'
RoxygenNote: 7.1.1
NeedsCompilation: no
Packaged: 2023-08-21 04:59:53 UTC; spav
Author: Steven E. Pav [aut, cre] (<https://orcid.org/0000-0002-4197-6195>)
Repository: CRAN
Date/Publication: 2023-08-21 07:42:32 UTC

## madness 0.10

=== Makefile ===
#****************************************************************************
#
# Makefile for TinyXml test.
# Lee Thomason
# www.grinninglizard.com
#
# This is a GNU make (gmake) makefile
#****************************************************************************

# DEBUG can be set to YES to include debugging info, or NO otherwise
DEBUG          := YES

# PROFILE can be set to YES to include profiling info, or NO otherwise
PROFILE        := NO

# TINYXML_USE_STL can be used to turn on STL support. NO, then STL
# will not be used. YES will include the STL files.
TINYXML_USE_STL := YES

#****************************************************************************

CC     := gcc
CXX    := g++
LD     := g++
AR     := ar rc
RANLIB := ranlib

DEBUG_CFLAGS     := -Wall -Wno-format -g -DDEBUG
RELEASE_CFLAGS   := -Wall -Wno-unknown-pragmas -Wno-format -O3

LIBS		 :=

DEBUG_CXXFLAGS   := ${DEBUG_CFLAGS} 
RELEASE_CXXFLAGS := ${RELEASE_CFLAGS}

DEBUG_LDFLAGS    := -g
RELEASE_LDFLAGS  :=

ifeq (YES, ${DEBUG})
   CFLAGS       := ${DEBUG_CFLAGS}
   CXXFLAGS     := ${DEBUG_CXXFLAGS}
   LDFLAGS      := ${DEBUG_LDFLAGS}
else
   CFLAGS       := ${RELEASE_CFLAGS}
   CXXFLAGS     := ${RELEASE_CXXFLAGS}
   LDFLAGS      := ${RELEASE_LDFLAGS}
endif

ifeq (YES, ${PROFILE})
   CFLAGS   := ${CFLAGS} -pg -O3
   CXXFLAGS := ${CXXFLAGS} -pg -O3
   LDFLAGS  := ${LDFLAGS} -pg
endif

#****************************************************************************
# Preprocessor directives
#****************************************************************************

ifeq (YES, ${TINYXML_USE_STL})
  DEFS := -DTIXML_USE_STL
else
  DEFS :=
endif

#****************************************************************************
# Include paths
#****************************************************************************

#INCS := -I/usr/include/g++-2 -I/usr/local/include
INCS :=


#****************************************************************************
# Makefile code common to all platforms
#****************************************************************************

CFLAGS   := ${CFLAGS}   ${DEFS}
CXXFLAGS := ${CXXFLAGS} ${DEFS}

#****************************************************************************
# Targets of the build
#****************************************************************************

OUTPUT := xmltest

all: ${OUTPUT}


#****************************************************************************
# Source files
#****************************************************************************

SRCS := tinyxml.cpp tinyxmlparser.cpp xmltest.cpp tinyxmlerror.cpp tinystr.cpp

# Add on the sources for libraries
SRCS := ${SRCS}

OBJS := $(addsuffix .o,$(basename ${SRCS}))

#****************************************************************************
# Output
#****************************************************************************

${OUTPUT}: ${OBJS}
	${LD} -o $@ ${LDFLAGS} ${OBJS} ${LIBS} ${EXTRA_LIBS}

#****************************************************************************
# common rules
#****************************************************************************

# Rules for compiling source files to object files
%.o : %.cpp
	${CXX} -c ${CXXFLAGS} ${INCS} $< -o $@

%.o : %.c
	${CC} -c ${CFLAGS} ${INCS} $< -o $@

dist:
	bash makedistlinux

clean:
	-rm -f core ${OBJS} ${OUTPUT}

depend:
	#makedepend ${INCS} ${SRCS}

tinyxml.o: tinyxml.h tinystr.h
tinyxmlparser.o: tinyxml.h tinystr.h
xmltest.o: tinyxml.h tinystr.h
tinyxmlerror.o: tinyxml.h tinystr.h

=== src/madness/external/elemental/CMakeLists.txt ===
#
#  Copyright (c) 2009-2014, Jack Poulson
#                     2012, Jed Brown 
#  All rights reserved.
#
#  This file is part of Elemental and is under the BSD 2-Clause License, 
#  which can be found in the LICENSE file in the root directory, or at 
#  http://opensource.org/licenses/BSD-2-Clause
#
cmake_minimum_required(VERSION 2.8.8)
include(CheckCSourceCompiles)
include(CheckCXXSourceCompiles)
include(CheckFunctionExists)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/external/cmake/")
include(GetGitRevisionDescription)
include(language_support_v2)

project(Elemental)
set(Elemental_VERSION_MAJOR 0)
set(Elemental_VERSION_MINOR 84-dev)

################################################################################
# Common build options                                                         #
################################################################################

# By default, Elemental builds static libraries, but shared libraries are 
# also supported through this option.
option(BUILD_SHARED_LIBS "Switch to shared libraries" OFF)

# Whether or not to build a collection of simple example drivers.
option(ELEM_EXAMPLES "A collection of simple examples" OFF)

# Whether or not to build a collection of performance and correctness tests
option(ELEM_TESTS "A collection of performance and correctness tests" OFF)

# Whether or not to force the Memory class zero initialize what it allocates.
# If valgrind was detected and is running, this will be forced anyway.
option(ELEM_ZERO_INIT "Initialize buffers to zero by default?" OFF)

# Whether or not to build current 'experimental' code, such as:
# Martin's 3D Gemm code
option(ELEM_EXPERIMENTAL "Build experimental code" OFF)

# Attempt to use 64-bit integers
option(ELEM_USE_64BIT_INTS "Use 64-bit integers where possible" OFF)

# Whether or not to use Qt5 for visualization if it is found (experimental)
# NOTE: Setting Qt5Widgets_DIR, Qt5_DIR, or Qt5_LIBDIR overrides this variable
option(ELEM_USE_QT5 "Attempt to use Qt5?" OFF)

################################################################################
# Advanced build options                                                       #
################################################################################

# Since it is surprisingly common for MPI libraries to have bugs in their 
# support for complex data, the following option forces Elemental to cast 
# all possible MPI communications in terms of twice as many real units of data.
option(ELEM_AVOID_COMPLEX_MPI "Avoid potentially buggy complex MPI routines" ON)
mark_as_advanced(ELEM_AVOID_COMPLEX_MPI)

# At one point, a bug was found in IBM's C++ compiler for Blue Gene/P, 
# where OpenMP statements of the form a[i] += alpha b[i], with complex data,
# would segfault and/or return incorrect results
option(ELEM_AVOID_OMP_FMA "Avoid a bug in the IBM compilers." OFF)
mark_as_advanced(ELEM_AVOID_OMP_FMA)

# Due to a subtle flaw in the Blue Gene/P extensions for MPICH2, treating 
# floating-point data as a collection of byte-sized objects results in a 
# better algorithm being chosen for MPI_Allgather. This should not effect
# performance on most machines.
option(ELEM_USE_BYTE_ALLGATHERS "Avoid BG/P allgather performance bug." ON)
mark_as_advanced(ELEM_USE_BYTE_ALLGATHERS)

# If MPI_Reduce_scatter_block doesn't exist, perform it by composing 
# MPI_Allreduce and std::memcpy rather than MPI_Reduce and MPI_Scatter
option(ELEM_REDUCE_SCATTER_BLOCK_VIA_ALLREDUCE
       "AllReduce based block MPI_Reduce_scatter" OFF)
mark_as_advanced(ELEM_REDUCE_SCATTER_BLOCK_VIA_ALLREDUCE)

# This can easily be performed, but is likely not a good idea
option(ELEM_POOL_MEMORY 
       "Make Memory class accumulate memory until destruction" OFF)
mark_as_advanced(ELEM_POOL_MEMORY)

################################################################################
# Elemental-development build options                                          #
################################################################################

# Print a warning any time a redistribution is performed which unpacks a 
# large amount of data with a non-unit stride
option(ELEM_CACHE_WARNINGS "Warns when using cache-unfriendly routines" OFF)
mark_as_advanced(ELEM_CACHE_WARNINGS)

# Print a warning when an improperly aligned redistribution is performed, 
# i.e., if an unnecessary permutation communication stage must take place
option(ELEM_UNALIGNED_WARNINGS 
       "Warn when performing unaligned redistributions" OFF)
mark_as_advanced(ELEM_UNALIGNED_WARNINGS)

# Print a warning if an opportunity was missed to implement a redistribution
# approach specifically for vectors (instead of matrices)
option(ELEM_VECTOR_WARNINGS 
       "Warn when vector redistribution chances are missed" OFF)
mark_as_advanced(ELEM_VECTOR_WARNINGS)

################################################################################
# Significant command-line variable definitions                                #
################################################################################

# "CMAKE_BUILD_TYPE"
#   Elemental requires it to be one of the following choices:
#     1. "PureDebug": Vanilla MPI build meant for development and debugging
#     2. "PureRelease": Vanilla MPI build meant for production runs
#     3. "HybridDebug": MPI+OpenMP build meant for development and debugging
#     4. "HybridRelease": MPI+OpenMP build meant for production runs
#   If "CMAKE_BUILD_TYPE" is not defined, the default is "PureRelease".

# "CXX_FLAGS"
#   Optimization and debugging/symbol flags

# "OpenMP_CXX_FLAGS"
#   Overrides the default compile flags for adding OpenMP support to CXX code

# TODO: Add list of MPI variables here, such as "MPI_CXX_COMPILE_FLAGS"

# TODO: Add discussion of "MATH_LIBS"

# TODO: Add discussion of "REFERENCE_ROOT"

# TODO: Check to see if there are any others...

################################################################################
# Build logic starts here                                                      #
################################################################################

# Elemental must be built "out-of-source", so we start by ensuring that the
# source and build directories are different.
if("${PROJECT_SOURCE_DIR}" STREQUAL "${PROJECT_BINARY_DIR}")
  message(FATAL_ERROR "In-source build attempted; please clean the CMake cache and then switch to an out-of-source build, e.g., rm CMakeCache.txt && rm -Rf CMakeFiles/ && mkdir build/ && cd build/ && cmake ..")
endif()

# Get the Git revision
get_git_head_revision(GIT_REFSPEC GIT_SHA1)

# Extract a few booleans from the build type and default to PureRelease
if(NOT CMAKE_BUILD_TYPE)
  message(STATUS "Build mode not specified, defaulting to PureRelease build.")
  set(CMAKE_BUILD_TYPE PureRelease)
endif()
if(CMAKE_BUILD_TYPE STREQUAL "HybridDebug")
  set(ELEM_HYBRID TRUE)
  set(ELEM_DEBUG TRUE)
elseif(CMAKE_BUILD_TYPE STREQUAL "HybridRelease")
  set(ELEM_HYBRID TRUE)
  set(ELEM_RELEASE TRUE)
elseif(CMAKE_BUILD_TYPE STREQUAL "PureDebug")
  set(ELEM_PURE TRUE)
  set(ELEM_DEBUG TRUE)
elseif(CMAKE_BUILD_TYPE STREQUAL "PureRelease")
  set(ELEM_PURE TRUE)
  set(ELEM_RELEASE TRUE)
else()
  message(FATAL_ERROR "CMAKE_BUILD_TYPE must be [Hybrid,Pure][Debug,Release]")
endif()
string(TOUPPER ${CMAKE_BUILD_TYPE} UPPER_BUILD_TYPE)

# Set the basic compile flags from the build type
if(NOT WIN32) # I forget why we need this guard
  set(LANGUAGES CXX C Fortran)
  foreach(LANG ${LANGUAGES})
    if(NOT ${LANG}_FLAGS)
      if(ELEM_DEBUG)
        # set(${LANG}_FLAGS "-O2 -g -Wunused-variable -Wunused-but-set-variable -Wunused-local-typedefs" CACHE STRING
        set(${LANG}_FLAGS "-O2 -g" CACHE STRING
          "${LANG} optimization/debug flags for ${UPPER_BUILD_TYPE} mode")
      else()
        set(${LANG}_FLAGS "-O3" CACHE STRING
          "${LANG} optimization flags for ${UPPER_BUILD_TYPE} mode")
      endif()
    endif()
  endforeach()
endif()

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/")
include(tests/Fortran)
include(tests/CXX)
include(tests/MPI)
include(tests/OpenMP)

include(tests/Qt5)
if(ELEM_HAVE_QT5)
  set(ELEM_HEADERS_PREMOC 
      "include/elemental/io/DisplayWindow-premoc.hpp;include/elemental/io/ComplexDisplayWindow-premoc.hpp")
  qt_wrap_cpp(elemental ELEM_MOC_SRC ${ELEM_HEADERS_PREMOC})
  include_directories(${Qt5Widgets_INCLUDE_DIRS})
  add_definitions(${Qt5Widgets_DEFINITIONS})
  set(EXTRA_FLAGS "${Qt5Widgets_EXECUTABLE_COMPILE_FLAGS} ${EXTRA_FLAGS}")

  # Qt5Widgets_DIR = Qt5_LIBDIR/cmake/Qt5Widgets
  get_filename_component(Qt5_CMAKEDIR ${Qt5Widgets_DIR} PATH)
  get_filename_component(Qt5_LIBDIR ${Qt5_CMAKEDIR} PATH)
endif()

include(FindValgrind)
if(VALGRIND_FOUND)
  include_directories(${VALGRIND_INCLUDE_DIR})
  set(ELEM_HAVE_VALGRIND TRUE)
endif()

include(tests/Math)

# Now append the extra flags
set(CXX_FLAGS "${CXX_FLAGS} ${EXTRA_FLAGS}")
set(CMAKE_CXX_FLAGS_${UPPER_BUILD_TYPE} ${CXX_FLAGS})

# Add the Parallel Multiple Relatively Robust Representations (PMRRR) project
add_subdirectory(external/pmrrr)

# Create the Elemental configuration header
configure_file(${PROJECT_SOURCE_DIR}/cmake/config.h.cmake
               ${PROJECT_BINARY_DIR}/include/elemental/config.h)
install(FILES ${PROJECT_BINARY_DIR}/include/elemental/config.h 
        DESTINATION include/elemental)

# Create a file which can be included in Makefile's.
# This is meant to be analogous to PETSc's 'conf/petscvariables' file
set(MPI_CXX_INCSTRING)
foreach(INC_PATH ${MPI_CXX_INCLUDE_PATH})
  set(MPI_CXX_INCSTRING "${MPI_CXX_INCSTRING} -I${INC_PATH}")  
endforeach()
set(MATH_LIBSTRING)
foreach(LIB ${MATH_LIBS})
  set(MATH_LIBSTRING "${MATH_LIBSTRING} ${LIB}")
endforeach()
set(MPI_CXX_LIBSTRING)
foreach(LIB ${MPI_CXX_LIBRARIES})
  set(MPI_CXX_LIBSTRING "${MPI_CXX_LIBSTRING} ${LIB}")
endforeach()
set(LAPACK_ADDONSTRING)
foreach(LIB ${LAPACK_ADDONS_LIBS})
  set(LAPACK_ADDONSTRING "${LAPACK_ADDONSTRING} ${LIB}")
endforeach()
set(QT5_DEFSTRING)
foreach(DEF ${Qt5Widgets_DEFINITIONS})
  set(QT5_DEFSTRING "${QT5_DEFSTRING} ${DEF}")
endforeach()
set(QT5_INCSTRING)
foreach(INC ${Qt5Widgets_INCLUDE_DIRS})
  set(QT5_INCSTRING "${QT5_INCSTRING} -I${INC}")
endforeach()
set(QT5_COMPILESTRING)
foreach(FLAG ${Qt5Widgets_EXECUTABLE_COMPILE_FLAGS})
  set(QT5_COMPILESTRING "${QT5_COMPILE_STRING} ${FLAG}")
endforeach()
set(QT5_LIBSTRING "-L${Qt5_LIBDIR} -lQt5Widgets -lQt5Gui -lQt5Core")
configure_file(${PROJECT_SOURCE_DIR}/cmake/ElemVars.cmake
               ${PROJECT_BINARY_DIR}/conf/ElemVars @ONLY)
install(FILES ${PROJECT_BINARY_DIR}/conf/ElemVars DESTINATION conf)

# Grab all of the .c, .cpp, .h, and .hpp Elemental files
file(GLOB_RECURSE ELEM_CPP RELATIVE ${PROJECT_SOURCE_DIR} "src/*.c" "src/*.cpp")
file(GLOB_RECURSE ELEM_HEADERS RELATIVE ${PROJECT_SOURCE_DIR} 
  "include/*.h" "include/*.hpp")
set(ELEM_SRC "${ELEM_CPP};${ELEM_HEADERS};${ELEM_MOC_SRC}")

# The main library
set(LINK_LIBS ${MATH_LIBS} ${MPI_CXX_LIBRARIES})
if(ELEM_HAVE_QT5)
  set(LINK_LIBS ${LINK_LIBS} ${Qt5Widgets_LIBRARIES})  
endif()
add_library(elemental ${LIBRARY_TYPE} ${ELEM_SRC})
target_link_libraries(elemental pmrrr ${LINK_LIBS})
if(MPI_CXX_LINK_FLAGS AND MPI_C_LINK_FLAGS)
  set(MPI_LINK_FLAGS "${MPI_CXX_LINK_FLAGS} ${MPI_C_LINK_FLAGS}")
elseif(MPI_CXX_LINK_FLAGS)
  set(MPI_LINK_FLAGS "${MPI_CXX_LINK_FLAGS}")
elseif(MPI_C_LINK_FLAGS)
  set(MPI_LINK_FLAGS "${MPI_C_LINK_FLAGS}")
endif()
install(TARGETS elemental DESTINATION lib)

# Define the header-file preparation rules
set(PREPARED_HEADERS)
foreach(HEADER ${ELEM_HEADERS})
  add_custom_command(OUTPUT ${PROJECT_BINARY_DIR}/${HEADER}
    COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_SOURCE_DIR}/${HEADER}
            ${PROJECT_BINARY_DIR}/${HEADER}
    DEPENDS "${PROJECT_SOURCE_DIR}/${HEADER}")
  list(APPEND PREPARED_HEADERS ${PROJECT_BINARY_DIR}/${HEADER})

  get_filename_component(HEADER_PATH ${HEADER} PATH)
  install(FILES ${PROJECT_BINARY_DIR}/${HEADER} DESTINATION ${HEADER_PATH})

=== src/madness/external/elemental/external/pmrrr/CMakeLists.txt ===
#
#  Copyright (c) 2009-2013, Jack Poulson
#                     2013, Jed Brown 
#  All rights reserved.
#
#  This file is part of Elemental and is under the BSD 2-Clause License, 
#  which can be found in the LICENSE file in the root directory, or at 
#  http://opensource.org/licenses/BSD-2-Clause
#

option(HAVE_SPINLOCKS "Enable if pthread lib supports spinlocks" OFF)
MARK_AS_ADVANCED(HAVE_SPINLOCKS)

set(CMAKE_REQUIRED_FLAGS "${MPI_C_COMPILE_FLAGS} ${MPI_C_LINK_FLAGS}")
set(CMAKE_REQUIRED_INCLUDES ${MPI_C_INCLUDE_PATH})
set(CMAKE_REQUIRED_LIBRARIES ${MPI_C_LIBRARIES})
check_function_exists(MPI_Query_thread HAVE_MPI_QUERY_THREAD)
if(NOT HAVE_MPI_QUERY_THREAD)
  message(FATAL_ERROR "Do not have MPI_Query_thread, so cannot build PMRRR")
endif()

# Add in the preprocessor definitions and fortran name-mangling
set(C_BASE_FLAGS "${ELEM_BLAS_DEFS} ${ELEM_LAPACK_DEFS}")
if(NOT HAVE_SPINLOCKS)
  set(C_BASE_FLAGS "${C_BASE_FLAGS} -DNOSPINLOCKS")
endif()

# Ensure that an MPI C compiler was found
if(NOT MPI_C_FOUND)
  message(FATAL_ERROR "No MPI C compiler was found, so PMRRR cannot be built")
endif()
include_directories(${MPI_C_INCLUDE_PATH})
    
set(CMAKE_C_FLAGS_${UPPER_BUILD_TYPE} "${C_BASE_FLAGS} ${C_FLAGS}")

# Look for a PTHREADS library unless one was already specified
if(NOT CMAKE_THREAD_LIBS_INIT)
  set(CMAKE_THREAD_PREFER_PTHREAD ON)
  find_package(Threads)
  if(NOT CMAKE_USE_PTHREADS_INIT)
    message(WARNING "Could not find a pthreads library, cannot build PMRRR")
    return()
  endif()
endif()

# Grab all of the .c and .h files
file(GLOB_RECURSE PMRRR_C RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "*.c")
file(GLOB_RECURSE PMRRR_H RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "*.h")
set(PMRRR_SRC "${PMRRR_C};${PMRRR_H}")

# Define the main library and its link libraries
add_library(pmrrr ${LIBRARY_TYPE} ${PMRRR_SRC})
target_link_libraries(pmrrr 
  ${MPI_C_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} ${MATH_LIBS})
install(TARGETS pmrrr DESTINATION lib)
set(CMAKE_THREAD_LIBS_INIT ${CMAKE_THREAD_LIBS_INIT} PARENT_SCOPE)

# Define the header-preparation rules
set(PREPARED_HEADERS)
foreach(HEADER ${PMRRR_H})
  add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${HEADER}
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/${HEADER}
            ${CMAKE_CURRENT_BINARY_DIR}/${HEADER}
    DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/${HEADER}")
  list(APPEND PREPARED_HEADERS ${CMAKE_CURRENT_BINARY_DIR}/${HEADER})

  get_filename_component(HEADER_PATH ${HEADER} PATH)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${HEADER} 
          DESTINATION ${HEADER_PATH})
endforeach()
add_custom_target(prepare_pmrrr_headers DEPENDS ${PREPARED_HEADERS})
add_dependencies(pmrrr prepare_pmrrr_headers)

# Make sure that the PMRRR headers can be found
include_directories("${CMAKE_CURRENT_BINARY_DIR}/include")

=== debian/changelog ===
madness (0.10-8) unstable; urgency=medium

  * debian/rules (override_dh_auto_test): Remove comma from
    make filter function. (Closes: #831546)

 -- Graham Inggs <ginggs@debian.org>  Sun, 17 Jul 2016 18:50:16 +0200

madness (0.10-7) unstable; urgency=medium

  * debian/patches/fix_glibc_2.23.patch: Cherrypick patch from upstream to use
    std::isnan from cmath and fix FTBFS, thanks Logan Rosen. (Closes: #818812)
  * debian/rules (OMPI_MCA): Replace obsolete orte_rsh_agent with plm_rsh_agent.
  * debian/rules (override_dh_auto_test): Disable tests on armel and i386.
  * debian/*: Fix various issues in copyright, unusual spacing in control,
    wrap-and-sort.
  * debian/control: Use secure URI for Vcs-Browser.
  * debian/control: Add myself to Uploaders.
  * debian/control: Bump Standards-Version to 3.9.8, no further changes.

 -- Graham Inggs <ginggs@debian.org>  Sat, 16 Jul 2016 14:03:33 +0200

madness (0.10-6) unstable; urgency=medium

  * debian/rules: Pass --disable-optimal to configure unless `custom' is set in
    DEB_BUILD_OPTIONS.  This prevents regular packages being built with
    -march=native.
  * debian/control (Build-Depends): Added mpi-default-bin.

 -- Michael Banck <mbanck@debian.org>  Mon, 18 Jan 2016 10:54:39 +0100

madness (0.10-5) unstable; urgency=medium

  * debian/rules (override_dh_auto_test): Set OMPI_MCA_orte_rsh_agent
    environment variable to make test suite run in a chroot without
    errors from OpenMPI.

 -- Michael Banck <mbanck@debian.org>  Sun, 17 Jan 2016 21:09:22 +0100

madness (0.10-4) unstable; urgency=medium

  [ Michael Banck ]
  * debian/control (Build-Depends): Replaced libopenmpi-dev with
    mpi-default-dev.
  * debian/rules (/usr/share/mpi-default-dev/debian_defaults): New included
    file.
  * debian/rules: Allow for parallel building, patch by Aron Xu 
    (Closes: #798246).
  * debian/rules (override_dh_auto_test): Print testuite results if one or more
    tests fail.
  * debian/patches/fix_cblas_definitions.patch: New patch, fixes cblas
    definitions, taken from upstream commit b244daad.

  [ Daniel Leidert ]
  * debian/watch: Added.

 -- Michael Banck <mbanck@debian.org>  Sun, 17 Jan 2016 16:48:21 +0100

madness (0.10-3) unstable; urgency=medium

  * debian/libmadness-dev.install: Update to reflect CMake config file
    directory change.

 -- Michael Banck <mbanck@debian.org>  Mon, 03 Aug 2015 10:44:40 +0200

madness (0.10-2) unstable; urgency=medium

  * debian/copyright: Updated for previously missed gtest code, thanks to
    Thorsten Alteholz.
  * debian/control (Vcs-Browser, Vcs-Svn): Fixed URLs.
  * debian/rules (override_dh_auto_test): Skip tests if nocheck is set in
    $(DEB_BUILD_OPTIONS).
  * debian/control (Description): Fix typo.
  * debian/patches/cmake_config.patch: New patch, fixes the CMake config file
    and installs it to the expected directory.
  * debian/patches/non_intel_asm_fix.patch: New patch, works around unportable
    assembler code, taken from upstream commit f679f8f5 (Closes: #794278).
  * debian/rules (override_dh_auto_clean): Remove files generated by
    autogen.sh.

 -- Michael Banck <mbanck@debian.org>  Mon, 03 Aug 2015 00:42:51 +0200

madness (0.10-1) unstable; urgency=medium

  * Initial upload (Closes: #658299).

 -- Michael Banck <mbanck@debian.org>  Sun, 05 Jul 2015 11:27:13 +0200

=== debian/control ===
Source: madness
Section: libdevel
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>, Graham Inggs <ginggs@debian.org>
Build-Depends: autoconf,
               automake,
               autotools-dev,
               debhelper (>= 9),
               libblas-dev,
               liblapack-dev,
               mpi-default-bin,
               mpi-default-dev
Standards-Version: 3.9.8
Homepage: https://github.com/m-a-d-n-e-s-s/madness
Vcs-Browser: https://anonscm.debian.org/viewvc/debichem/unstable/madness/
Vcs-Svn: svn://anonscm.debian.org/debichem/unstable/madness/

Package: libmadness-dev
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Numerical Environment for Scientific Simulation (development files)
 MADNESS (Multiresolution Adaptive Numerical Environment for Scientific
 Simulation) provides a high-level environment for the solution of integral and
 differential equations in many dimensions using adaptive, fast methods with
 guaranteed precision based on multi-resolution analysis and novel separated
 representations. There are three main components to MADNESS. At the lowest
 level is a new petascale parallel programming environment that increases
 programmer productivity and code performance/scalability while maintaining
 backward compatibility with current programming tools such as MPI and Global
 Arrays. The numerical capabilities built upon the parallel tools provide a
 high-level environment for composing and solving numerical problems in many
 (1-6+) dimensions. Finally, built upon the numerical tools are new
 applications with initial focus upon chemistry, atomic and molecular physics,
 material science, and nuclear structure.
 .
 This package contains the static libraries and the header files.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export OMPI_MCA_plm_rsh_agent=/bin/false

# Disable optimal compiler flags (like -march=native) unless
# DEB_BUILD_OPTIONS=custom is set
ifeq (,$(filter custom,$(DEB_BUILD_OPTIONS)))
CXXFLAGS_OPTS=--disable-optimal
else
CXXFLAGS_OPTS=--enable-optimal
endif

include /usr/share/mpi-default-dev/debian_defaults

%:
	dh $@ --parallel --with autotools-dev

override_dh_auto_clean:
	-dh_auto_clean
	rm -f config/missing config/config.sub config/depcomp config/config.guess config/test-driver config/compile config/install-sh
	rm -f aclocal.m4 configure doc/doxygen.cfg src/madness/config.h.in
	rm -f src/madness/mra/fplot.dat src/madness/mra/opf.dat src/madness/mra/opfplot.dat src/madness/mra/testline1  src/madness/mra/testline2 src/madness/mra/testline3 src/madness/mra/testplot src/madness/world/test.dat src/madness/world/testme.ar
	rm -f doc/Makefile src/apps/exciting/Makefile src/apps/hf/Makefile src/apps/interior_bc/Makefile src/apps/nick/Makefile src/apps/polar/Makefile
	find . -name "Makefile.in" | xargs rm -f

override_dh_auto_configure:
	./autogen.sh
	dh_auto_configure -- ${CXXFLAGS_OPTS}

override_dh_auto_install:
	dh_auto_install --destdir=$(CURDIR)/debian/tmp

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifeq (,$(filter $(DEB_HOST_ARCH),armel i386))
	-dh_auto_test || cat src/madness/world/test-suite.log
endif
endif
